# CfnNodegroup

Creates a managed node group for an Amazon EKS cluster.

You can only create a node group for your cluster that is equal to the current Kubernetes version for the cluster. All node groups are created with the latest AMI release version for the respective minor Kubernetes version of the cluster, unless you deploy a custom AMI using a launch template.

For later updates, you will only be able to update a node group using a launch template only if it was originally deployed with a launch template. Additionally, the launch template ID or name must match what was used when the node group was created. You can update the launch template version with necessary changes. For more information about using launch templates, see [Customizing managed nodes with launch templates](https://docs.aws.amazon.com/eks/latest/userguide/launch-templates.html) .

An Amazon EKS managed node group is an Amazon EC2 Auto Scaling group and associated Amazon EC2 instances that are managed by AWS for an Amazon EKS cluster. For more information, see [Managed node groups](https://docs.aws.amazon.com/eks/latest/userguide/managed-node-groups.html) in the *Amazon EKS User Guide* .

> Windows AMI types are only supported for commercial AWS Regions that support Windows on Amazon EKS.

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnNodegroup
Implements: IInspectable, ITaggable, IEnvironmentAware, INodegroupRef, IConstruct, IDependable

- CloudFormation: [`AWS::EKS::Nodegroup`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-eks-nodegroup.html)
- Source: Generated code
- Type last changed: v2.252.0 · 30 Apr 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_eks as eks } from 'aws-cdk-lib';
const cfnNodegroup = new eks.CfnNodegroup(this, 'MyCfnNodegroup', {
  clusterName: 'clusterName',
  nodeRole: 'nodeRole',
  subnets: ['subnets'],

  // the properties below are optional
  amiType: 'amiType',
  capacityType: 'capacityType',
  diskSize: 123,
  forceUpdateEnabled: false,
  instanceTypes: ['instanceTypes'],
  labels: {
    labelsKey: 'labels',
  },
  launchTemplate: {
    id: 'id',
    name: 'name',
    version: 'version',
  },
  nodegroupName: 'nodegroupName',
  nodeRepairConfig: {
    enabled: false,
    maxParallelNodesRepairedCount: 123,
    maxParallelNodesRepairedPercentage: 123,
    maxUnhealthyNodeThresholdCount: 123,
    maxUnhealthyNodeThresholdPercentage: 123,
    nodeRepairConfigOverrides: [{
      minRepairWaitTimeMins: 123,
      nodeMonitoringCondition: 'nodeMonitoringCondition',
      nodeUnhealthyReason: 'nodeUnhealthyReason',
      repairAction: 'repairAction',
    }],
  },
  releaseVersion: 'releaseVersion',
  remoteAccess: {
    ec2SshKey: 'ec2SshKey',

    // the properties below are optional
    sourceSecurityGroups: ['sourceSecurityGroups'],
  },
  scalingConfig: {
    desiredSize: 123,
    maxSize: 123,
    minSize: 123,
  },
  tags: {
    tagsKey: 'tags',
  },
  taints: [{
    effect: 'effect',
    key: 'key',
    value: 'value',
  }],
  updateConfig: {
    maxUnavailable: 123,
    maxUnavailablePercentage: 123,
    updateStrategy: 'updateStrategy',
  },
  version: 'version',
  warmPoolConfig: {
    enabled: false,
    maxGroupPreparedCapacity: 123,
    minSize: 123,
    poolState: 'poolState',
    reuseOnScaleIn: false,
  },
});
```

## Initializer

```ts
new CfnNodegroup(scope: Construct, id: string, props: CfnNodegroupProps)
```

## Construct Props

- `amiType`: string — The AMI type for your node group.

  If you specify `launchTemplate` , and your launch template uses a custom AMI, then don't specify `amiType` , or the node group deployment will fail. If your launch template uses a Windows custom AMI, then add `eks:kube-proxy-windows` to your Windows nodes `rolearn` in the `aws-auth` `ConfigMap` . For more information about using launch templates with Amazon EKS, see [Customizing managed nodes with launch templates](https://docs.aws.amazon.com/eks/latest/userguide/launch-templates.html) in the *Amazon EKS User Guide* .

- `capacityType`: string — The capacity type of your managed node group.

- `clusterName`: string | [IClusterRef](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_eks.IClusterRef.html) (required) — The name of your cluster.

- `diskSize`: number — The root device disk size (in GiB) for your node group instances.

  The default disk size is 20 GiB for Linux and Bottlerocket. The default disk size is 50 GiB for Windows. If you specify `launchTemplate` , then don't specify `diskSize` , or the node group deployment will fail. For more information about using launch templates with Amazon EKS, see [Customizing managed nodes with launch templates](https://docs.aws.amazon.com/eks/latest/userguide/launch-templates.html) in the *Amazon EKS User Guide* .

- `forceUpdateEnabled`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) = false — Force the update if any `Pod` on the existing node group can't be drained due to a `Pod` disruption budget issue.

  If an update fails because all Pods can't be drained, you can force the update after it fails to terminate the old node whether or not any `Pod` is running on the node.

- `instanceTypes`: string[] — Specify the instance types for a node group.

  If you specify a GPU instance type, make sure to also specify an applicable GPU AMI type with the `amiType` parameter. If you specify `launchTemplate` , then you can specify zero or one instance type in your launch template *or* you can specify 0-20 instance types for `instanceTypes` . If however, you specify an instance type in your launch template *and* specify any `instanceTypes` , the node group deployment will fail. If you don't specify an instance type in a launch template or for `instanceTypes` , then `t3.medium` is used, by default. If you specify `Spot` for `capacityType` , then we recommend specifying multiple values for `instanceTypes` . For more information, see [Managed node group capacity types](https://docs.aws.amazon.com/eks/latest/userguide/managed-node-groups.html#managed-node-group-capacity-types) and [Customizing managed nodes with launch templates](https://docs.aws.amazon.com/eks/latest/userguide/launch-templates.html) in the *Amazon EKS User Guide* .

- `labels`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | { [key: string]: string } — The Kubernetes `labels` applied to the nodes in the node group.

  > Only `labels` that are applied with the Amazon EKS API are shown here. There may be other Kubernetes `labels` applied to the nodes in this group.

- `launchTemplate`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnNodegroup.LaunchTemplateSpecificationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_eks.CfnNodegroup.LaunchTemplateSpecificationProperty.html) — An object representing a node group's launch template specification.

  When using this object, don't directly specify `instanceTypes` , `diskSize` , or `remoteAccess` . You cannot later specify a different launch template ID or name than what was used to create the node group.

  Make sure that the launch template meets the requirements in `launchTemplateSpecification` . Also refer to [Customizing managed nodes with launch templates](https://docs.aws.amazon.com/eks/latest/userguide/launch-templates.html) in the *Amazon EKS User Guide* .

- `nodegroupName`: string — The unique name to give your node group.

- `nodeRepairConfig`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnNodegroup.NodeRepairConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_eks.CfnNodegroup.NodeRepairConfigProperty.html) — The node auto repair configuration for the node group.

- `nodeRole`: string | [IRoleRef](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_iam.IRoleRef.html) (required) — The Amazon Resource Name (ARN) of the IAM role to associate with your node group.

  The Amazon EKS worker node `kubelet` daemon makes calls to AWS APIs on your behalf. Nodes receive permissions for these API calls through an IAM instance profile and associated policies. Before you can launch nodes and register them into a cluster, you must create an IAM role for those nodes to use when they are launched. For more information, see [Amazon EKS node IAM role](https://docs.aws.amazon.com/eks/latest/userguide/create-node-role.html) in the **Amazon EKS User Guide** . If you specify `launchTemplate` , then don't specify `[IamInstanceProfile](https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_IamInstanceProfile.html)` in your launch template, or the node group deployment will fail. For more information about using launch templates with Amazon EKS, see [Customizing managed nodes with launch templates](https://docs.aws.amazon.com/eks/latest/userguide/launch-templates.html) in the *Amazon EKS User Guide* .

- `releaseVersion`: string — The AMI version of the Amazon EKS optimized AMI to use with your node group (for example, `1.14.7- *YYYYMMDD*` ). By default, the latest available AMI version for the node group's current Kubernetes version is used. For more information, see [Amazon EKS optimized Linux AMI Versions](https://docs.aws.amazon.com/eks/latest/userguide/eks-linux-ami-versions.html) in the *Amazon EKS User Guide* .

  > Changing this value triggers an update of the node group if one is available. You can't update other properties at the same time as updating `Release Version` .

- `remoteAccess`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnNodegroup.RemoteAccessProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_eks.CfnNodegroup.RemoteAccessProperty.html) — The remote access configuration to use with your node group.

  For Linux, the protocol is SSH. For Windows, the protocol is RDP. If you specify `launchTemplate` , then don't specify `remoteAccess` , or the node group deployment will fail. For more information about using launch templates with Amazon EKS, see [Customizing managed nodes with launch templates](https://docs.aws.amazon.com/eks/latest/userguide/launch-templates.html) in the *Amazon EKS User Guide* .

- `scalingConfig`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnNodegroup.ScalingConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_eks.CfnNodegroup.ScalingConfigProperty.html) — The scaling configuration details for the Auto Scaling group that is created for your node group.

- `subnets`: string | [ISubnetRef](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_ec2.ISubnetRef.html)[] (required) — The subnets to use for the Auto Scaling group that is created for your node group.

  If you specify `launchTemplate` , then don't specify `[SubnetId](https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateNetworkInterface.html)` in your launch template, or the node group deployment will fail. For more information about using launch templates with Amazon EKS, see [Customizing managed nodes with launch templates](https://docs.aws.amazon.com/eks/latest/userguide/launch-templates.html) in the *Amazon EKS User Guide* .

- `tags`: { [key: string]: string } — Metadata that assists with categorization and organization.

  Each tag consists of a key and an optional value. You define both. Tags don't propagate to any other cluster or AWS resources.

- `taints`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnNodegroup.TaintProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_eks.CfnNodegroup.TaintProperty.html)[] — The Kubernetes taints to be applied to the nodes in the node group when they are created.

  Effect is one of `No_Schedule` , `Prefer_No_Schedule` , or `No_Execute` . Kubernetes taints can be used together with tolerations to control how workloads are scheduled to your nodes. For more information, see [Node taints on managed node groups](https://docs.aws.amazon.com/eks/latest/userguide/node-taints-managed-node-groups.html) .

- `updateConfig`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnNodegroup.UpdateConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_eks.CfnNodegroup.UpdateConfigProperty.html) — The node group update configuration.

- `version`: string — The Kubernetes version to use for your managed nodes.

  By default, the Kubernetes version of the cluster is used, and this is the only accepted specified value. If you specify `launchTemplate` , and your launch template uses a custom AMI, then don't specify `version` , or the node group deployment will fail. For more information about using launch templates with Amazon EKS, see [Launch template support](https://docs.aws.amazon.com/eks/latest/userguide/launch-templates.html) in the *Amazon EKS User Guide* .

  > You can't update other properties at the same time as updating `Version` .

- `warmPoolConfig`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnNodegroup.WarmPoolConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_eks.CfnNodegroup.WarmPoolConfigProperty.html) — The warm pool configuration for the node group.

## Properties

- `amiType`: string — The AMI type for your node group.

- `attrArn`: string — The Amazon Resource Name (ARN) associated with the managed node group.

- `attrClusterName`: string — The name of your cluster.

- `attrId`: string

- `attrNodegroupName`: string — The name associated with an Amazon EKS managed node group.

- `capacityType`: string — The capacity type of your managed node group.

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `clusterName`: string — The name of your cluster.

- `creationStack`: string[]

- `diskSize`: number — The root device disk size (in GiB) for your node group instances.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `forceUpdateEnabled`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Force the update if any `Pod` on the existing node group can't be drained due to a `Pod` disruption budget issue.

- `instanceTypes`: string[] — Specify the instance types for a node group.

- `labels`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | { [key: string]: string } — The Kubernetes `labels` applied to the nodes in the node group.

- `launchTemplate`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnNodegroup.LaunchTemplateSpecificationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_eks.CfnNodegroup.LaunchTemplateSpecificationProperty.html) — An object representing a node group's launch template specification.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `nodegroupName`: string — The unique name to give your node group.

- `nodegroupRef`: [NodegroupReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_eks.NodegroupReference.html) — A reference to a Nodegroup resource.

- `nodeRepairConfig`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnNodegroup.NodeRepairConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_eks.CfnNodegroup.NodeRepairConfigProperty.html) — The node auto repair configuration for the node group.

- `nodeRole`: string — The Amazon Resource Name (ARN) of the IAM role to associate with your node group.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `releaseVersion`: string — The AMI version of the Amazon EKS optimized AMI to use with your node group (for example, `1.14.7- *YYYYMMDD*` ). By default, the latest available AMI version for the node group's current Kubernetes version is used. For more information, see [Amazon EKS optimized Linux AMI Versions](https://docs.aws.amazon.com/eks/latest/userguide/eks-linux-ami-versions.html) in the *Amazon EKS User Guide* .

- `remoteAccess`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnNodegroup.RemoteAccessProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_eks.CfnNodegroup.RemoteAccessProperty.html) — The remote access configuration to use with your node group.

- `scalingConfig`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnNodegroup.ScalingConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_eks.CfnNodegroup.ScalingConfigProperty.html) — The scaling configuration details for the Auto Scaling group that is created for your node group.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `subnets`: string[] — The subnets to use for the Auto Scaling group that is created for your node group.

- `tags`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `tagsRaw`: { [key: string]: string } — Metadata that assists with categorization and organization.

- `taints`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnNodegroup.TaintProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_eks.CfnNodegroup.TaintProperty.html)[] — The Kubernetes taints to be applied to the nodes in the node group when they are created.

- `updateConfig`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnNodegroup.UpdateConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_eks.CfnNodegroup.UpdateConfigProperty.html) — The node group update configuration.

- `version`: string — The Kubernetes version to use for your managed nodes.

- `warmPoolConfig`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnNodegroup.WarmPoolConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_eks.CfnNodegroup.WarmPoolConfigProperty.html) — The warm pool configuration for the node group.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForNodegroup(resource: INodegroupRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnNodegroup(x: any): boolean` (static) — Checks whether the given object is a CfnNodegroup.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
